Index: /XIOS/dev/dev_olga/src/filter/spatial_transform_filter.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/filter/spatial_transform_filter.cpp	(revision 1583)
+++ /XIOS/dev/dev_olga/src/filter/spatial_transform_filter.cpp	(revision 1584)
@@ -201,5 +201,5 @@
     const std::list<CGridTransformation::RecvIndexGridDestinationMap>& listLocalIndexToReceive = gridTransformation->getLocalIndexToReceiveOnGridDest();
     const std::list<size_t>& listNbLocalIndexToReceive = gridTransformation->getNbLocalIndexToReceiveOnGridDest();
-    const std::list<std::vector<bool> >& listLocalIndexMaskOnDest = gridTransformation->getLocalMaskIndexOnGridDest();
+//    const std::list<std::vector<bool> >& listLocalIndexMaskOnDest = gridTransformation->getLocalMaskIndexOnGridDest();
     const std::vector<CGenericAlgorithmTransformation*>& listAlgos = gridTransformation->getAlgos();
 
@@ -210,8 +210,9 @@
     std::list<CGridTransformation::RecvIndexGridDestinationMap>::const_iterator itListRecv = listLocalIndexToReceive.begin();
     std::list<size_t>::const_iterator itNbListRecv = listNbLocalIndexToReceive.begin();
-    std::list<std::vector<bool> >::const_iterator itLocalMaskIndexOnDest = listLocalIndexMaskOnDest.begin();
+//    std::list<std::vector<bool> >::const_iterator itLocalMaskIndexOnDest = listLocalIndexMaskOnDest.begin();
     std::vector<CGenericAlgorithmTransformation*>::const_iterator itAlgo = listAlgos.begin();
 
-    for (; itListSend != iteListSend; ++itListSend, ++itListRecv, ++itNbListRecv, ++itLocalMaskIndexOnDest, ++itAlgo)
+//    for (; itListSend != iteListSend; ++itListSend, ++itListRecv, ++itNbListRecv, ++itLocalMaskIndexOnDest, ++itAlgo)
+    for (; itListSend != iteListSend; ++itListSend, ++itListRecv, ++itNbListRecv, ++itAlgo)
     {
       CArray<double,1> dataCurrentSrc(dataCurrentDest);
@@ -266,8 +267,9 @@
 
       dataCurrentDest.resize(*itNbListRecv);
-      const std::vector<bool>& localMaskDest = *itLocalMaskIndexOnDest;
-      for (int i = 0; i < localMaskDest.size(); ++i)
-        if (localMaskDest[i]) dataCurrentDest(i) = 0.0;
-        else dataCurrentDest(i) = defaultValue;
+      dataCurrentDest = 0.0;
+//      const std::vector<bool>& localMaskDest = *itLocalMaskIndexOnDest;
+//      for (int i = 0; i < localMaskDest.size(); ++i)
+//        if (localMaskDest[i]) dataCurrentDest(i) = 0.0;
+//        else dataCurrentDest(i) = defaultValue;
 
       std::vector<bool> localInitFlag(dataCurrentDest.numElements(), true);
Index: /XIOS/dev/dev_olga/src/node/grid.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/node/grid.cpp	(revision 1583)
+++ /XIOS/dev/dev_olga/src/node/grid.cpp	(revision 1584)
@@ -432,40 +432,40 @@
 */
 
-  void CGrid::getLocalMask(CArray<bool,1>& localMask)
-  {
-      std::vector<CDomain*> domainP = this->getDomains();
-      std::vector<CAxis*> axisP = this->getAxis();
-      int dim = domainP.size() * 2 + axisP.size();
-
-      switch (dim)
-      {
-        case 0:
-          getLocalMask(mask_0d, localMask);
-          break;
-        case 1:
-          getLocalMask(mask_1d, localMask);
-          break;
-        case 2:
-          getLocalMask(mask_2d, localMask);
-          break;
-        case 3:
-          getLocalMask(mask_3d, localMask);
-          break;
-        case 4:
-          getLocalMask(mask_4d, localMask);
-          break;
-        case 5:
-          getLocalMask(mask_5d, localMask);
-          break;
-        case 6:
-          getLocalMask(mask_6d, localMask);
-          break;
-        case 7:
-          getLocalMask(mask_7d, localMask);
-          break;
-        default:
-          break;
-      }
-  }
+//  void CGrid::getLocalMask(CArray<bool,1>& localMask)
+//  {
+//      std::vector<CDomain*> domainP = this->getDomains();
+//      std::vector<CAxis*> axisP = this->getAxis();
+//      int dim = domainP.size() * 2 + axisP.size();
+//
+//      switch (dim)
+//      {
+//        case 0:
+//          getLocalMask(mask_0d, localMask);
+//          break;
+//        case 1:
+//          getLocalMask(mask_1d, localMask);
+//          break;
+//        case 2:
+//          getLocalMask(mask_2d, localMask);
+//          break;
+//        case 3:
+//          getLocalMask(mask_3d, localMask);
+//          break;
+//        case 4:
+//          getLocalMask(mask_4d, localMask);
+//          break;
+//        case 5:
+//          getLocalMask(mask_5d, localMask);
+//          break;
+//        case 6:
+//          getLocalMask(mask_6d, localMask);
+//          break;
+//        case 7:
+//          getLocalMask(mask_7d, localMask);
+//          break;
+//        default:
+//          break;
+//      }
+//  }
       
    /*
Index: /XIOS/dev/dev_olga/src/node/grid.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/node/grid.hpp	(revision 1583)
+++ /XIOS/dev/dev_olga/src/node/grid.hpp	(revision 1584)
@@ -205,7 +205,7 @@
          bool hasTransform();
          size_t getGlobalWrittenSize(void) ;
-         void getLocalMask(CArray<bool,1>& localMask) ;
-         template<int N>
-         void getLocalMask(const CArray<bool,N>& gridMask, CArray<bool,1>& localMask) ;
+//         void getLocalMask(CArray<bool,1>& localMask) ;
+//         template<int N>
+//         void getLocalMask(const CArray<bool,N>& gridMask, CArray<bool,1>& localMask) ;
       public:
          CArray<int, 1> storeIndex_client;
@@ -573,39 +573,39 @@
   \param [in] multi-dimension array grid mask
 */
-template<int N>
-void CGrid::getLocalMask(const CArray<bool,N>& gridMask, CArray<bool,1>& localMask)
-{
-  if (gridMask.isEmpty()) return ;
-  int dim = gridMask.dimensions();
-  std::vector<int> dimensionSizes(dim);
-  for (int i = 0; i < dim; ++i) dimensionSizes[i] = gridMask.extent(i);
-
-  std::vector<int> idxLoop(dim,0);
-  int ssize = gridMask.numElements(), idx = 0;
-  localMask.resize(ssize);
-  while (idx < ssize)
-  {
-    for (int i = 0; i < dim-1; ++i)
-    {
-      if (idxLoop[i] == dimensionSizes[i])
-      {
-        idxLoop[i] = 0;
-        ++idxLoop[i+1];
-      }
-    }
-
-    int maskIndex = idxLoop[0];
-    int mulDim = 1;
-    for (int k = 1; k < dim; ++k)
-    {
-      mulDim *= dimensionSizes[k-1];
-      maskIndex += idxLoop[k]*mulDim;
-    }
-    localMask(maskIndex) = *(gridMask.dataFirst()+maskIndex);
-
-    ++idxLoop[0];
-    ++idx;
-  }
-}
+//template<int N>
+//void CGrid::getLocalMask(const CArray<bool,N>& gridMask, CArray<bool,1>& localMask)
+//{
+//  if (gridMask.isEmpty()) return ;
+//  int dim = gridMask.dimensions();
+//  std::vector<int> dimensionSizes(dim);
+//  for (int i = 0; i < dim; ++i) dimensionSizes[i] = gridMask.extent(i);
+//
+//  std::vector<int> idxLoop(dim,0);
+//  int ssize = gridMask.numElements(), idx = 0;
+//  localMask.resize(ssize);
+//  while (idx < ssize)
+//  {
+//    for (int i = 0; i < dim-1; ++i)
+//    {
+//      if (idxLoop[i] == dimensionSizes[i])
+//      {
+//        idxLoop[i] = 0;
+//        ++idxLoop[i+1];
+//      }
+//    }
+//
+//    int maskIndex = idxLoop[0];
+//    int mulDim = 1;
+//    for (int k = 1; k < dim; ++k)
+//    {
+//      mulDim *= dimensionSizes[k-1];
+//      maskIndex += idxLoop[k]*mulDim;
+//    }
+//    localMask(maskIndex) = *(gridMask.dataFirst()+maskIndex);
+//
+//    ++idxLoop[0];
+//    ++idx;
+//  }
+//}
 
    // Declare/Define CGridGroup and CGridDefinition
Index: /XIOS/dev/dev_olga/src/transformation/generic_algorithm_transformation.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/transformation/generic_algorithm_transformation.cpp	(revision 1583)
+++ /XIOS/dev/dev_olga/src/transformation/generic_algorithm_transformation.cpp	(revision 1584)
@@ -843,7 +843,11 @@
 
 
-
 void CGenericAlgorithmTransformation::computeTransformationMappingNonDistributed(int elementPositionInGrid, CGrid* gridSrc, CGrid* gridDst,
-                                                                                 vector<int>& localSrc, vector<int>& localDst, vector<double>& weight, vector<bool>& localMaskOnGridDest)
+                                                                                 vector<int>& localSrc, vector<int>& localDst, vector<double>& weight,
+                                                                                 int nlocalIndexDest)
+
+//void CGenericAlgorithmTransformation::computeTransformationMappingNonDistributed(int elementPositionInGrid, CGrid* gridSrc, CGrid* gridDst,
+//                                                                                 vector<int>& localSrc, vector<int>& localDst, vector<double>& weight,
+//                                                                                 vector<bool>& localMaskOnGridDest)
 {
 
@@ -871,5 +875,6 @@
     
   int nlocalIndexSrc=1 ;
-  int nlocalIndexDest=1 ;
+//  int nlocalIndexDest=1 ;
+  nlocalIndexDest=1 ;
   CArray<bool,1> maskScalar(1) ;
   maskScalar  = true ;
@@ -933,9 +938,4 @@
     nlocalIndexDest=nlocalIndexDest*nIndexDst[i] ;
   }
-
-
-
-
-
 
   vector<int> dstLocalInd ;
@@ -986,15 +986,15 @@
 
 // just get the local src mask
-  CArray<bool,1> localMaskOnSrcGrid;
-  gridSrc->getLocalMask(localMaskOnSrcGrid) ;
+//  CArray<bool,1> localMaskOnSrcGrid;
+//  gridSrc->getLocalMask(localMaskOnSrcGrid) ;
 // intermediate grid, mask is not initialized => set up mask to true
-  if (localMaskOnSrcGrid.isEmpty())
-  {
-    localMaskOnSrcGrid.resize(nlocalIndexSrc) ;
-    localMaskOnSrcGrid=true ;
-  }
-  
-
-  localMaskOnGridDest.resize(nlocalIndexDest,false) ;
+//  if (localMaskOnSrcGrid.isEmpty())
+//  {
+//    localMaskOnSrcGrid.resize(nlocalIndexSrc) ;
+//    localMaskOnSrcGrid=true ;
+//  }
+  
+
+//  localMaskOnGridDest.resize(nlocalIndexDest,false) ;
 
   vector<vector<vector<pair<int,double> > > > dstIndWeight(transformationMapping_.size()) ;
@@ -1023,12 +1023,21 @@
   int srcIndCompressed=0 ;
   
+//  nonDistributedrecursiveFunct(nElement-1,true,elementPositionInGrid,maskSrc,maskDst, srcInd, srcIndCompressed, nIndexSrc, t, dstIndWeight,
+//                               currentInd,localSrc,localDst,weight, localMaskOnSrcGrid, localMaskOnGridDest );
+//  nonDistributedrecursiveFunct(nElement-1,true,elementPositionInGrid,maskSrc,maskDst, srcInd, srcIndCompressed, nIndexSrc, t, dstIndWeight,
+//                               currentInd,localSrc,localDst,weight, localMaskOnGridDest );
   nonDistributedrecursiveFunct(nElement-1,true,elementPositionInGrid,maskSrc,maskDst, srcInd, srcIndCompressed, nIndexSrc, t, dstIndWeight,  
-                               currentInd,localSrc,localDst,weight, localMaskOnSrcGrid, localMaskOnGridDest );
+                               currentInd,localSrc,localDst,weight);
                
 }
 
 
-void CGenericAlgorithmTransformation::nonDistributedrecursiveFunct(int currentPos, bool masked, int elementPositionInGrid, vector< CArray<bool,1>* >& maskSrc, vector< CArray<bool,1>* >& maskDst, int& srcInd, int& srcIndCompressed, vector<int>& nIndexSrc, int& t, vector<vector<vector<pair<int,double> > > >& dstIndWeight, int currentInd,
-                    vector<int>& localSrc, vector<int>& localDst, vector<double>& weight,  CArray<bool,1>& localMaskOnGridSrc, vector<bool>& localMaskOnGridDest )
+void CGenericAlgorithmTransformation::nonDistributedrecursiveFunct(int currentPos, bool masked, int elementPositionInGrid,
+                                                                   vector< CArray<bool,1>* >& maskSrc, vector< CArray<bool,1>* >& maskDst,
+                                                                   int& srcInd, int& srcIndCompressed, vector<int>& nIndexSrc,
+                                                                   int& t, vector<vector<vector<pair<int,double> > > >& dstIndWeight, int currentInd,
+                                                                   vector<int>& localSrc, vector<int>& localDst, vector<double>& weight)
+//                                                                   CArray<bool,1>& localMaskOnGridSrc
+//                                                                   , vector<bool>& localMaskOnGridDest )
 {
   int masked_ ;
@@ -1043,5 +1052,7 @@
         masked_=masked ;
         if (!mask(i)) masked_=false ;
-        nonDistributedrecursiveFunct(currentPos-1, masked_, elementPositionInGrid, maskSrc, maskDst, srcInd, srcIndCompressed, nIndexSrc, t, dstIndWeight, currentInd, localSrc, localDst, weight, localMaskOnGridSrc, localMaskOnGridDest) ;
+//        nonDistributedrecursiveFunct(currentPos-1, masked_, elementPositionInGrid, maskSrc, maskDst, srcInd, srcIndCompressed, nIndexSrc, t, dstIndWeight, currentInd, localSrc, localDst, weight, localMaskOnGridSrc, localMaskOnGridDest) ;
+        nonDistributedrecursiveFunct(currentPos-1, masked_, elementPositionInGrid, maskSrc, maskDst, srcInd, srcIndCompressed, nIndexSrc, t,
+                                     dstIndWeight, currentInd, localSrc, localDst, weight);//, localMaskOnGridDest) ;
       }
     }
@@ -1057,10 +1068,10 @@
             for(vector<pair<int,double> >::iterator it = dstIndWeight[t][currentInd].begin(); it!=dstIndWeight[t][currentInd].end(); ++it)
             {
-              if (localMaskOnGridSrc(srcInd))
+//              if (localMaskOnGridSrc(srcInd))
               {
                 localSrc.push_back(srcIndCompressed) ;
                 localDst.push_back(it->first) ;
                 weight.push_back(it->second) ;
-                localMaskOnGridDest[it->first]=true ;
+//                localMaskOnGridDest[it->first]=true ;
               }
               (it->first)++ ;
@@ -1068,5 +1079,6 @@
           }
           if (t < dstIndWeight.size()-1) t++ ;
-          if (localMaskOnGridSrc(srcInd)) srcIndCompressed ++ ;
+//          if (localMaskOnGridSrc(srcInd))
+            srcIndCompressed ++ ;
         }
         srcInd++ ;
@@ -1086,5 +1098,8 @@
         masked_=masked ;
         if (!mask(i)) masked_=false ; 
-        nonDistributedrecursiveFunct(currentPos-1, masked_, elementPositionInGrid, maskSrc, maskDst, srcInd, srcIndCompressed, nIndexSrc, t, dstIndWeight , i,  localSrc, localDst, weight, localMaskOnGridSrc, localMaskOnGridDest) ;
+        nonDistributedrecursiveFunct(currentPos-1, masked_, elementPositionInGrid, maskSrc, maskDst, srcInd,
+                                     srcIndCompressed, nIndexSrc, t, dstIndWeight , i,  localSrc, localDst, weight);
+//                                     localMaskOnGridSrc,
+//                                     localMaskOnGridDest) ;
       }
     }
@@ -1100,10 +1115,10 @@
             for(vector<pair<int,double> >::iterator it = dstIndWeight[t][i].begin(); it!=dstIndWeight[t][i].end(); ++it)
             {
-              if (localMaskOnGridSrc(srcInd))
+//              if (localMaskOnGridSrc(srcInd))
               {
                 localSrc.push_back(srcIndCompressed) ;
                 localDst.push_back(it->first) ;
                 weight.push_back(it->second) ;
-                localMaskOnGridDest[it->first]=true ;
+//                localMaskOnGridDest[it->first]=true ;
               }
               (it->first)++ ;
@@ -1111,5 +1126,6 @@
            }
           if (t < dstIndWeight.size()-1) t++ ;
-          if (localMaskOnGridSrc(srcInd)) srcIndCompressed ++ ;
+//          if (localMaskOnGridSrc(srcInd))
+            srcIndCompressed ++ ;
         }
         srcInd++ ;
Index: /XIOS/dev/dev_olga/src/transformation/generic_algorithm_transformation.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/transformation/generic_algorithm_transformation.hpp	(revision 1583)
+++ /XIOS/dev/dev_olga/src/transformation/generic_algorithm_transformation.hpp	(revision 1584)
@@ -87,8 +87,18 @@
   */
   void computeIndexSourceMapping(const std::vector<CArray<double,1>* >& dataAuxInputs = std::vector<CArray<double,1>* >());
+//  void computeTransformationMappingNonDistributed(int elementPositionInGrid, CGrid* gridSrc, CGrid* gridDst,
+//                                                  vector<int>& localSrc, vector<int>& localDst, vector<double>& weight, vector<bool>& localMaskOnGridDest);
   void computeTransformationMappingNonDistributed(int elementPositionInGrid, CGrid* gridSrc, CGrid* gridDst,
-                                                  vector<int>& localSrc, vector<int>& localDst, vector<double>& weight, vector<bool>& localMaskOnGridDest);
-  void nonDistributedrecursiveFunct(int currentPos, bool masked, int elementPositionInGrid,  vector< CArray<bool,1>* >& maskSrc, vector< CArray<bool,1>* >& maskDst, int& srcInd, int& srcIndCompressed, vector<int>& nIndexSrc, int& t, vector<vector<vector<pair<int,double> > > >& dstIndWeight, int currentInd,
-                                     vector<int>& localSrc, vector<int>& localDst, vector<double>& weight, CArray<bool,1>& localMaskOnGridSrc, vector<bool>& localMaskOnGridDest) ;
+                                                  vector<int>& localSrc, vector<int>& localDst, vector<double>& weight, int nbLocalIndexOnGridDest);
+//  void nonDistributedrecursiveFunct(int currentPos, bool masked, int elementPositionInGrid,  vector< CArray<bool,1>* >& maskSrc, vector< CArray<bool,1>* >& maskDst, int& srcInd, int& srcIndCompressed, vector<int>& nIndexSrc, int& t, vector<vector<vector<pair<int,double> > > >& dstIndWeight, int currentInd,
+//                                     vector<int>& localSrc, vector<int>& localDst, vector<double>& weight, CArray<bool,1>& localMaskOnGridSrc, vector<bool>& localMaskOnGridDest) ;
+//  void nonDistributedrecursiveFunct(int currentPos, bool masked, int elementPositionInGrid,  vector< CArray<bool,1>* >& maskSrc, vector< CArray<bool,1>* >& maskDst,
+//                                    int& srcInd, int& srcIndCompressed, vector<int>& nIndexSrc,
+//                                    int& t, vector<vector<vector<pair<int,double> > > >& dstIndWeight, int currentInd,
+//                                    vector<int>& localSrc, vector<int>& localDst, vector<double>& weight, vector<bool>& localMaskOnGridDest) ;
+  void nonDistributedrecursiveFunct(int currentPos, bool masked, int elementPositionInGrid,  vector< CArray<bool,1>* >& maskSrc, vector< CArray<bool,1>* >& maskDst,
+                                    int& srcInd, int& srcIndCompressed, vector<int>& nIndexSrc,
+                                    int& t, vector<vector<vector<pair<int,double> > > >& dstIndWeight, int currentInd,
+                                    vector<int>& localSrc, vector<int>& localDst, vector<double>& weight) ;
 
 protected:
Index: /XIOS/dev/dev_olga/src/transformation/grid_transformation.cpp
===================================================================
--- /XIOS/dev/dev_olga/src/transformation/grid_transformation.cpp	(revision 1583)
+++ /XIOS/dev/dev_olga/src/transformation/grid_transformation.cpp	(revision 1584)
@@ -346,5 +346,5 @@
       std::list<RecvIndexGridDestinationMap>().swap(localIndexToReceiveOnGridDest_);
       std::list<size_t>().swap(nbLocalIndexOnGridDest_);
-      std::list<std::vector<bool> >().swap(localMaskOnGridDest_);
+//      std::list<std::vector<bool> >().swap(localMaskOnGridDest_);
     }
     else
@@ -399,12 +399,17 @@
         vector<int> localDst ;
         vector<double> weight ;
-        localMaskOnGridDest_.push_back(vector<bool>()) ;
+        int nbLocalIndexOnGridDest;
+//        localMaskOnGridDest_.push_back(vector<bool>()) ;
         CTimer::get("computeTransformationMappingNonDistributed").resume();  
+//        algo->computeTransformationMappingNonDistributed(elementPosition, gridSource_, tmpGridDestination_,
+//                                                         localSrc, localDst, weight, localMaskOnGridDest_.back()) ;
         algo->computeTransformationMappingNonDistributed(elementPosition, gridSource_, tmpGridDestination_, 
-                                                         localSrc, localDst, weight, localMaskOnGridDest_.back()) ;
+                                                         localSrc, localDst, weight, nbLocalIndexOnGridDest) ;
         CTimer::get("computeTransformationMappingNonDistributed").suspend();  
 
         CTimer::get("computeTransformationMappingConvert").resume();  
-        nbLocalIndexOnGridDest_.push_back(localMaskOnGridDest_.back().size()) ;
+//        nbLocalIndexOnGridDest_.push_back(localMaskOnGridDest_.back().size()) ;
+//        nbLocalIndexOnGridDest_.push_back(localMaskOnGridDest_.back().size()) ;
+        nbLocalIndexOnGridDest_.push_back(nbLocalIndexOnGridDest) ;
         int clientRank=client->clientRank ;
         {
@@ -472,7 +477,7 @@
   size_t nbLocalIndex = globalLocalIndexGridDestSendToServer.size();
   nbLocalIndexOnGridDest_.push_back(nbLocalIndex);
-  localMaskOnGridDest_.push_back(std::vector<bool>());
-  std::vector<bool>& tmpMask = localMaskOnGridDest_.back();
-  tmpMask.resize(nbLocalIndex,false);
+//  localMaskOnGridDest_.push_back(std::vector<bool>());
+//  std::vector<bool>& tmpMask = localMaskOnGridDest_.back();
+//  tmpMask.resize(nbLocalIndex,false);
 
   // Find out number of index sent from grid source and number of index received on grid destination
@@ -657,5 +662,5 @@
         recvTmp[recvRank][realRecvSize].first = globalLocalIndexGridDestSendToServer[recvIndexDst(idx)];
         recvTmp[recvRank][realRecvSize].second = recvWeightDst(idx);
-        tmpMask[globalLocalIndexGridDestSendToServer[recvIndexDst(idx)]] = true;
+//        tmpMask[globalLocalIndexGridDestSendToServer[recvIndexDst(idx)]] = true;
          ++realRecvSize;
       }
@@ -714,8 +719,8 @@
   \return local mask of data
 */
-const std::list<std::vector<bool> >& CGridTransformation::getLocalMaskIndexOnGridDest() const
-{
-  return localMaskOnGridDest_;
-}
-
-}
+//const std::list<std::vector<bool> >& CGridTransformation::getLocalMaskIndexOnGridDest() const
+//{
+//  return localMaskOnGridDest_;
+//}
+
+}
Index: /XIOS/dev/dev_olga/src/transformation/grid_transformation.hpp
===================================================================
--- /XIOS/dev/dev_olga/src/transformation/grid_transformation.hpp	(revision 1583)
+++ /XIOS/dev/dev_olga/src/transformation/grid_transformation.hpp	(revision 1584)
@@ -49,5 +49,5 @@
   const std::list<RecvIndexGridDestinationMap>& getLocalIndexToReceiveOnGridDest() const;
   const std::list<size_t>& getNbLocalIndexToReceiveOnGridDest() const;
-  const std::list<std::vector<bool> >& getLocalMaskIndexOnGridDest() const;
+//  const std::list<std::vector<bool> >& getLocalMaskIndexOnGridDest() const;
 
   CGrid* getGridSource() { return originalGridSource_; }
@@ -84,5 +84,5 @@
   //! Number of local index of data to receive on grid destination
   std::list<size_t> nbLocalIndexOnGridDest_;
-  std::list<std::vector<bool> > localMaskOnGridDest_;
+//  std::list<std::vector<bool> > localMaskOnGridDest_;
 
   bool dynamicalTransformation_;