Index: /XIOS/dev/dev_trunk_omp/arch/arch-IRENE_omp.env
===================================================================
--- /XIOS/dev/dev_trunk_omp/arch/arch-IRENE_omp.env	(revision 1607)
+++ /XIOS/dev/dev_trunk_omp/arch/arch-IRENE_omp.env	(revision 1608)
@@ -9,6 +9,7 @@
 module load feature/bridge/heterogenous_mpmd
 
-module unload netcdf
-module unload hdf5
+#module unload netcdf
+#module unload hdf5
+#module unload netcdf-fortran
 
 export HDF5_INC_DIR=$HOME/lib/hdf5_intel/include
Index: /XIOS/dev/dev_trunk_omp/arch/arch-IRENE_omp.fcm
===================================================================
--- /XIOS/dev/dev_trunk_omp/arch/arch-IRENE_omp.fcm	(revision 1607)
+++ /XIOS/dev/dev_trunk_omp/arch/arch-IRENE_omp.fcm	(revision 1608)
@@ -3,5 +3,5 @@
 ################################################################################
 
-%CCOMPILER      mpicc -qopenmp -D_usingEP -D_openmpi -std=c++11
+%CCOMPILER      mpicc -qopenmp -D_usingEP -D_intelmpi -std=c++11
 %FCOMPILER      mpif90 -qopenmp
 %LINKER         mpif90 -qopenmp -nofor-main -Wl,-rpath -Wl,$HOME/lib/netcdf_f_intel/lib
Index: /XIOS/dev/dev_trunk_omp/arch/arch-IRENE_omp.path
===================================================================
--- /XIOS/dev/dev_trunk_omp/arch/arch-IRENE_omp.path	(revision 1607)
+++ /XIOS/dev/dev_trunk_omp/arch/arch-IRENE_omp.path	(revision 1608)
@@ -1,5 +1,5 @@
 NETCDF_INCDIR="-I $NETCDFC_INCDIR -I $NETCDFFORTRAN_INCDIR -I $NETCDF_INC_DIR -I $HOME/lib/netcdf_f_intel/include"
 NETCDF_LIBDIR="-L $NETCDFC_LIBDIR -L $NETCDFFORTRAN_LIBDIR -L $NETCDF_LIB_DIR -L $HOME/lib/netcdf_f_intel/lib"
-NETCDF_LIB="-lnetcdf -lnetcdff"
+NETCDF_LIB="-lnetcdf -lnetcdff -lnetcdf"
 
 MPI_INCDIR=""
Index: /XIOS/dev/dev_trunk_omp/bld.cfg
===================================================================
--- /XIOS/dev/dev_trunk_omp/bld.cfg	(revision 1607)
+++ /XIOS/dev/dev_trunk_omp/bld.cfg	(revision 1608)
@@ -50,5 +50,6 @@
 #bld::target test_xios2_cmip6.exe
 #bld::target test_new_features.exe test_unstruct_complete.exe 
-#bld::target test_remap.exe
+bld::target test_remap.exe
+bld::target test_remap_omp.exe
 #bld::target test_complete.exe
 bld::target test_complete_omp.exe
Index: /XIOS/dev/dev_trunk_omp/inputs/REMAP/iodef.xml
===================================================================
--- /XIOS/dev/dev_trunk_omp/inputs/REMAP/iodef.xml	(revision 1607)
+++ /XIOS/dev/dev_trunk_omp/inputs/REMAP/iodef.xml	(revision 1608)
@@ -114,5 +114,5 @@
        <generate_rectilinear_domain id="domain_regular_pole"/>
        <interpolate_domain/>       
-       <zoom_domain ibegin="0" ni="45" jbegin="0" nj="45" />
+       <!--<zoom_domain ibegin="0" ni="45" jbegin="0" nj="45" /> -->
      </domain>
      <domain id="dst_domain_regular" ni_glo="90" nj_glo="45" type="rectilinear">
Index: /XIOS/dev/dev_trunk_omp/src/test/test_remap_omp.f90
===================================================================
--- /XIOS/dev/dev_trunk_omp/src/test/test_remap_omp.f90	(revision 1607)
+++ /XIOS/dev/dev_trunk_omp/src/test/test_remap_omp.f90	(revision 1608)
@@ -17,9 +17,9 @@
   TYPE(xios_context) :: ctx_hdl
 
-  DOUBLE PRECISION,ALLOCATABLE :: src_lon(:), dst_lon(:), src_lon_tmp(:)
-  DOUBLE PRECISION,ALLOCATABLE :: src_lat(:), dst_lat(:), src_lat_tmp(:)
+  DOUBLE PRECISION,ALLOCATABLE :: src_lon(:), dst_lon(:)
+  DOUBLE PRECISION,ALLOCATABLE :: src_lat(:), dst_lat(:)
   DOUBLE PRECISION,ALLOCATABLE :: src_boundslon(:,:), dst_boundslon(:,:)
   DOUBLE PRECISION,ALLOCATABLE :: src_boundslat(:,:), dst_boundslat(:,:)
-  DOUBLE PRECISION,ALLOCATABLE :: src_field_2D(:), src_field_2D_clone(:)
+  DOUBLE PRECISION,ALLOCATABLE :: src_field_2D(:)
   DOUBLE PRECISION,ALLOCATABLE :: tmp_field_0(:), tmp_field_1(:), tmp_field_2(:)
   DOUBLE PRECISION,ALLOCATABLE :: src_field_3D(:,:), src_field_4D(:,:,:), lval(:), lval1(:), lval2(:), src_field_pression(:,:)
@@ -37,5 +37,5 @@
   INTEGER :: varid
   INTEGER :: ts
-  INTEGER :: i,j
+  INTEGER :: i
   INTEGER,PARAMETER :: llm=5, interpolatedLlm = 4, llm2 = 6
   DOUBLE PRECISION, PARAMETER :: missing_value = 100000
@@ -83,9 +83,9 @@
   ENDIF
 
-  ALLOCATE(src_lon(src_ni), src_lon_tmp(src_ni))
-  ALLOCATE(src_lat(src_ni), src_lat_tmp(src_ni))
+  ALLOCATE(src_lon(src_ni))
+  ALLOCATE(src_lat(src_ni))
   ALLOCATE(src_boundslon(src_nvertex,src_ni))
   ALLOCATE(src_boundslat(src_nvertex,src_ni))
-  ALLOCATE(src_field_2D(src_ni), src_field_2D_clone(src_ni))
+  ALLOCATE(src_field_2D(src_ni))
   ALLOCATE(src_field_3D(src_ni,llm))
   ALLOCATE(src_field_4D(src_ni,llm,llm2))
@@ -111,30 +111,19 @@
   DO i=1,src_ni
     src_field_3D(i,:) = src_field_2D(i)
-    IF ((0 < src_lat(i)) .AND. (src_lat(i) < 25.5) .AND. (30 < src_lon(i)) .AND. (src_lon(i) < 60)) THEN
+    IF (MOD(i,10)==0) THEN
       src_mask_2D(i)=.FALSE.
-      ! src_field_2D(i) = missing_value
     ELSE
-      src_mask_2D(i)=.TRUE.      
+      src_mask_2D(i)=.TRUE.
     ENDIF
-    src_lon_tmp(i) = src_lon(i) + 1000
-    src_lat_tmp(i) = src_lat(i) + 10000
-  ENDDO
-  src_field_2D_clone = src_field_2D
+  ENDDO
 
   DO i=1,llm
     lval(i) = i*100
     src_field_pression(:,i) = i * 100
-    IF (MOD(i,3)==0) THEN
-      ! src_field_pression(:,i) = missing_value
-      src_field_3D(:,i) = missing_value
-    ELSE
-      ! src_field_pression(:,i) = i * 100
-      src_field_3D(:,i) = src_field_3D(:,i) + i * 10 
-    ENDIF
-    ! src_field_3D(:,i) = src_field_3D(:,i) + i * 10    
+    src_field_3D(:,i) = src_field_3D(:,i) + i * 10    
   ENDDO
 
   DO i=1,llm2
-    src_field_4D(:,:,i) = src_field_3D(:,:) + i * 100
+    src_field_4D(:,:,i) = src_field_3D(:,:)
   ENDDO
 
@@ -206,9 +195,4 @@
                             bounds_lon_1D=dst_boundslon, bounds_lat_1D=dst_boundslat, nvertex=dst_nvertex)
 
-  !CALL xios_set_domain_attr("src_domain_unstructured_read", ni_glo=src_ni_glo, ibegin=src_ibegin, ni=src_ni, type="unstructured")
-  !CALL xios_set_domain_attr("src_domain_unstructured_read", lonvalue_1D=src_lon_tmp, latvalue_1D=src_lat_tmp, &
-  !                          bounds_lon_1D=src_boundslon, bounds_lat_1D=src_boundslat, nvertex=src_nvertex)
-
-
   dtime%second = 3600
   CALL xios_set_timestep(dtime)
@@ -226,5 +210,5 @@
   !CALL xios_get_domain_attr("src_domain_unstructured_read", ni=src_tmp_ni, nj=src_tmp_nj)
   !ALLOCATE(tmp_field_2(src_tmp_ni*src_tmp_nj))
-  
+
   DO ts=1,1
     CALL xios_recv_field("src_field_regular", tmp_field_0)
@@ -232,12 +216,4 @@
     !CALL xios_recv_field("src_field_unstructured", tmp_field_2)
     CALL xios_update_calendar(ts)
-    
-    !DO i=1,src_ni
-    !  src_field_2D_clone(i) = src_field_2D(i)
-    !  IF ((23.5 * ts < src_lat(i)) .AND. (src_lat(i) < 65.5 *ts) .AND. (0 < src_lon(i)) .AND. (src_lon(i) < 30*ts)) THEN      
-    !    src_field_2D_clone(i) = missing_value    
-    !  ENDIF
-    !ENDDO
-
     CALL xios_send_field("src_field_2D",src_field_2D)
     CALL xios_send_field("src_field_2D_clone",src_field_2D)
@@ -255,12 +231,9 @@
   DEALLOCATE(src_lon, src_lat, src_boundslon,src_boundslat, src_field_2D)
   DEALLOCATE(dst_lon, dst_lat, dst_boundslon,dst_boundslat)
-  DEALLOCATE(tmp_field_0)
-  !DEALLOCATE(tmp_field_1)
-  !DEALLOCATE(tmp_field_2)
-  
-  CALL xios_finalize()
-  
-  print *, "Client : xios_finalize ", rank
-
+  ! DEALLOCATE(tmp_field_0, tmp_field_1, tmp_field_2)
+  
+  CALL xios_finalize() 
+  print *, "Client : xios_finalize OK", rank, size
+  
   !$omp barrier
 
@@ -290,2 +263,3 @@
 
 
+